(*
 * badpow : int * int -> int
 * REQUIRES: k >= 0
 * ENSURES: badpow (n, k) ==> n^k (where 0^0 is defined as 1)
 *)
fun badpow (n:int, k:int) : int = 
  if k = 0
  then 1 
  else if k mod 2 = 0 
  then badpow (n, k div 2) * badpow (n, k div 2) 
  else n * badpow (n, k div 2) * badpow (n, k div 2) 


val 1 = badpow (5, 0)
val 1 = badpow (0, 0)
val 25 = badpow (5, 2)
val 1 = badpow (~1, 2)