(*
 * pow : int * int -> int
 * REQUIRES: k >= 0
 * ENSURES: pow (n, k) ==> n^k (where 0^0 is defined as 1)
 *)
 fun pow (n:int, k:int) : int = 
  (case k of
      0 => 1 
    | _ => n * pow (n, k - 1)
  )

val 1 = pow (5, 0)
val 1 = pow (0, 0)
val 25 = pow (5, 2)
val 1 = pow (~1, 2)





